import { NgForOfContext } from "@angular/common";
import { ChangeDetectorRef, ComponentFactoryResolver, ComponentRef, DoCheck, EventEmitter, IterableChanges, IterableDiffers, NgZone, OnChanges, OnDestroy, OnInit, SimpleChanges, TemplateRef, TrackByFunction, ViewContainerRef } from "@angular/core";
import { DisplayContainerComponent } from "./display.container";
import { IForOfState } from "./IForOfState";
export declare class IgxForOfDirective<T> implements OnInit, OnChanges, DoCheck, OnDestroy {
    private _viewContainer;
    private _template;
    private _differs;
    private resolver;
    cdr: ChangeDetectorRef;
    private _zone;
    igxForOf: any[];
    igxForScrollOrientation: string;
    igxForScrollContainer: any;
    igxForContainerSize: any;
    igxForItemSize: any;
    dc: ComponentRef<DisplayContainerComponent>;
    state: IForOfState;
    totalItemCount: number;
    igxForRemote: boolean;
    onChunkLoad: EventEmitter<IForOfState>;
    onChunkPreload: EventEmitter<IForOfState>;
    private hScroll;
    private func;
    private hCache;
    private vh;
    private hvh;
    private _differ;
    private _trackByFn;
    private _lastTouchX;
    private _lastTouchY;
    private _pointerCapture;
    private _gestureObject;
    private _isScrolledToBottom;
    private _maxHeight;
    private _virtHeight;
    private _virtHeightRatio;
    private _virtScrollTop;
    private _bScrollInternal;
    private displayContiner;
    private virtualHelper;
    private _embeddedViews;
    constructor(_viewContainer: ViewContainerRef, _template: TemplateRef<NgForOfContext<T>>, _differs: IterableDiffers, resolver: ComponentFactoryResolver, cdr: ChangeDetectorRef, _zone: NgZone);
    protected readonly isRemote: boolean;
    ngOnInit(): void;
    ngOnDestroy(): void;
    ngOnChanges(changes: SimpleChanges): void;
    ngDoCheck(): void;
    addScrollTop(addTop: number): void;
    scrollTo(index: any): void;
    scrollNext(): void;
    scrollPrev(): void;
    getColumnScrollLeft(colIndex: any): number;
    getVerticalScroll(): any;
    getHorizontalScroll(): any;
    protected onScroll(event: any): void;
    protected fixedUpdateAllRows(inScrollTop: number, scrollHeight: number): number;
    protected onHScroll(event: any): void;
    protected fixedUpdateAllCols(inScrollLeft: any): number;
    protected onWheel(event: any): void;
    protected onTouchStart(event: any): boolean;
    protected onTouchMove(event: any): boolean;
    protected onPointerDown(event: any): boolean;
    protected onPointerUp(event: any): boolean;
    protected onMSGestureStart(event: any): boolean;
    protected onMSGestureChange(event: any): boolean;
    igxForTrackBy: TrackByFunction<T>;
    protected _applyChanges(changes: IterableChanges<T>): void;
    protected _calcMaxBrowserHeight(): number;
    protected _calculateChunkSize(): number;
    protected getElement(viewref: any, nodeName: any): any;
    protected initHCache(cols: any[]): number;
    protected getHorizontalIndexAt(left: any, set: any, index: any): any;
    private _recalcScrollBarSize();
    private _calcHeight();
    private _recalcOnContainerChange(changes);
    protected removeLastElem(): void;
    protected addLastElem(): void;
    private applyChunkSizeChange();
}
export declare function getTypeNameForDebugging(type: any): string;
export declare class IgxForOfModule {
}
